#!/usr/bin/env python3
import sys
import os
import argparse
import kbtools

__script_desc__='This script displays the list of detected cores and topology.'
__version_info__ = (1, 0, 0)
__version__ = '.'.join(map(str,__version_info__))

def main(args=None):
   parser = argparse.ArgumentParser(description=__script_desc__)
   parser.add_argument('-v', '--version', help='show program version', 
                       action='version',
                       version='{} version {}\n'.format(os.path.basename(__file__), __version__))
   args = parser.parse_args(args)

   print ("CPU topology")
   print ("============")
   print ('')
   sockets, cores, core_map = kbtools.get_cpu_topology()
   kbtools.disp_cpu_topology(sockets, cores, core_map)
   print ('')

if __name__ == '__main__':
   sys.exit(main())

